/* A minimal Screen Save. */
#include <windows.h>
#include <scrnsave.h>
#include <commctrl.h>
#include <stdio.h>
#include <string.h>
#include "res\resource.h"


#define MAXSPEED 100
#define DELAYMAX 999
#define MSGSIZE 80

/*This is the message */
char str[MSGSIZE+1] = "Det r bara hookers!!!!!";

/*This is timer delay */
long delay;

/*Text speed */
static textXSpeed = 10;
static textYSpeed = 5;

unsigned long datatype, datasize;
unsigned long result;

/* This is a regestry key. */
HKEY hRegKey;

/* Screen Saver function. */
LRESULT CALLBACK ScreenSaverProc(HWND hwnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	static HDC hdc;
    static HDC memdc;    
    static HBITMAP hbit;        
    static timer;
	static RECT scrdim;
	static SIZE size;
	static X = 0, Y = 0;
	static HBRUSH hBlkBrush;
	static TEXTMETRIC tm;	

	switch(message)
	{
	case WM_CREATE:
        /* open screen saver key or create, if necessary */
        RegCreateKeyEx(HKEY_CURRENT_USER,
                       "Software\\CyberTech\\Screensaver",
                       0, "Screen Saver", 0, KEY_ALL_ACCESS,
                       NULL, &hRegKey, &result);

        /* if key was created */
        if(result==REG_CREATED_NEW_KEY)
        {
            /* set its initial value */
            delay = 100;
            RegSetValueEx(hRegKey, "delay", 0,
                          REG_DWORD, (LPBYTE) &delay, sizeof(DWORD));
            RegSetValueEx(hRegKey, "message", 0,
                          REG_SZ, (LPBYTE) str, sizeof(str)+1);
            RegSetValueEx(hRegKey, "textXSpeed", 0,
                          REG_DWORD, (LPBYTE) &textXSpeed, sizeof(DWORD));
            RegSetValueEx(hRegKey, "textYSpeed", 0,
                          REG_DWORD, (LPBYTE) &textYSpeed, sizeof(DWORD));


        }
        else                            /* key was already in regestry */
        {                               /* get delay value */
            datasize = sizeof(DWORD);
            RegQueryValueEx(hRegKey, "delay", NULL,
                &datatype, (LPBYTE) &delay, &datasize);
            /* Speed */
            RegQueryValueEx(hRegKey, "textXSpeed", NULL,
                &datatype, (LPBYTE) &textXSpeed, &datasize);
            RegQueryValueEx(hRegKey, "textYSpeed", NULL,
                &datatype, (LPBYTE) &textYSpeed, &datasize);

            /* message */
            datasize = MSGSIZE;
            RegQueryValueEx(hRegKey, "message", NULL,
                            &datatype, (LPBYTE) str, &datasize);
        }

        RegCloseKey(hRegKey);

        timer = SetTimer(hwnd, 1, delay, NULL);
        hBlkBrush = GetStockObject(BLACK_BRUSH);


        hdc = GetDC(hwnd);
        /*Ger coordinates of screen */
        GetClientRect(hwnd, &scrdim);

        /* get and save height and length of string. */
        GetTextMetrics(hdc, &tm);
        GetTextExtentPoint32(hdc, str, strlen(str), &size);

        ReleaseDC(hwnd, hdc);

        /* Create memdc, background save area */
        memdc = CreateCompatibleDC(hdc);
        hbit = CreateCompatibleBitmap(hdc, size.cx+textXSpeed, size.cy+textYSpeed);
        SelectObject(memdc, hbit);
        BitBlt(memdc, 0, 0, size.cx+textXSpeed, size.cy+textYSpeed, hdc, X, Y, SRCCOPY);

        break;
	case WM_ERASEBKGND:
//        hdc = GetDC(hwnd);

//        /*Ger coordinates of screen */
//        GetClientRect(hwnd, &scrdim);

//          /*erase the screen */
//          SetBkColor(hdc, RGB(0, 0, 0));
//          PatBlt(hdc, 0, 0, scrdim.right, scrdim.bottom, PATCOPY);

//        /* get and save height and length of string. */
//        GetTextMetrics(hdc, &tm);
//        GetTextExtentPoint32(hdc, str, strlen(str), &size);

//        ReleaseDC(hwnd, hdc);
        break;

	case WM_TIMER:
		hdc = GetDC(hwnd);

		/*erase previous output */
        BitBlt(hdc, X, Y, size.cx, size.cy, memdc, 0, 0, SRCCOPY);

		/* move string to new location */
        X += textXSpeed; Y += textYSpeed;
        if (X > scrdim.right  - size.cx) textXSpeed = (textXSpeed * -1);
        if (Y > scrdim.bottom - size.cy) textYSpeed = (textYSpeed * -1);
        if (X < 0) textXSpeed = (textXSpeed * -1);
        if (Y < 0) textYSpeed = (textYSpeed * -1);

        /* save the background */
        BitBlt(memdc, 0, 0, size.cx, size.cy, hdc, X, Y, SRCCOPY);

        /* output string */
        SetBkColor(hdc, RGB(0, 0, 0));
        SetTextColor(hdc, RGB(0, 25, 255));
        SetBkMode(hdc, TRANSPARENT);
        TextOut(hdc, X, Y, str, strlen(str));


		ReleaseDC(hwnd, hdc);
		break;
  	case WM_DESTROY:
		KillTimer(hwnd, timer);
		break;
	default:
		return DefScreenSaverProc(hwnd, message, wParam, lParam);
	}

	return 0;
}

/*Configuration dialog box function */
BOOL CALLBACK ScreenSaverConfigureDialog(HWND hdwnd, UINT message,
										 WPARAM wParam, LPARAM lParam)
{
    static HWND hEboxWnd;
    static HWND udWnd;
    int low=1, high=DELAYMAX;

    switch(message)
    {
        case WM_INITDIALOG :

            /* open screen saver key or create, if necessary */
            RegCreateKeyEx(HKEY_CURRENT_USER,
                        "Software\\CyberTech\\Screensaver",
                        0, "Screen Saver", 0, KEY_ALL_ACCESS,
                        NULL, &hRegKey, &result);

            /* if key was created */
            if(result==REG_CREATED_NEW_KEY)
            {
                /* set its initial value */
                delay = 100;
                textXSpeed = 10;
                textXSpeed = 5;

                RegSetValueEx(hRegKey, "delay", 0,
                            REG_DWORD, (LPBYTE) &delay, sizeof(DWORD));
                RegSetValueEx(hRegKey, "message", 0,
                            REG_SZ, (LPBYTE) str, sizeof(str)+1);
                RegSetValueEx(hRegKey, "textXSpeed", 0,
                            REG_DWORD, (LPBYTE) &textXSpeed, sizeof(DWORD));
                RegSetValueEx(hRegKey, "textYSpeed", 0,
                            REG_DWORD, (LPBYTE) &textYSpeed, sizeof(DWORD));
            }
            else                            /* key was already in regestry */
            {                               /* get delay value */
                datasize = sizeof(DWORD);
                RegQueryValueEx(hRegKey, "delay", NULL,
                    &datatype, (LPBYTE) &delay, &datasize);

                /* Speed */
                RegQueryValueEx(hRegKey, "textXSpeed", NULL,
                    &datatype, (LPBYTE) &textXSpeed, &datasize);
                RegQueryValueEx(hRegKey, "textYSpeed", NULL,
                    &datatype, (LPBYTE) &textYSpeed, &datasize);

                /* message */
                datasize = MSGSIZE;
                RegQueryValueEx(hRegKey, "message", NULL,
                                &datatype, (LPBYTE) str, &datasize);
            }

            /* create delay spin control */
            hEboxWnd = GetDlgItem(hdwnd, IDD_EB1);
            udWnd = CreateUpDownControl(WS_CHILD | WS_BORDER | WS_VISIBLE |
                                        UDS_SETBUDDYINT | UDS_ALIGNRIGHT,
                                        20, 10, 50, 50,
                                        hdwnd,
                                        IDD_UPDOWN1,
                                        hMainInstance,
                                        hEboxWnd,
                                        DELAYMAX, 1, delay);

            /* create textXSpeed spin control */
            hEboxWnd = GetDlgItem(hdwnd, IDD_EB3);
            udWnd = CreateUpDownControl(WS_CHILD | WS_BORDER | WS_VISIBLE |
                                        UDS_SETBUDDYINT | UDS_ALIGNRIGHT,
                                        20, 25, 50, 50,
                                        hdwnd,
                                        IDD_UPDOWN2,
                                        hMainInstance,
                                        hEboxWnd,
                                        MAXSPEED, 1, textXSpeed);

            /* create textYSpeed spin control */
            hEboxWnd = GetDlgItem(hdwnd, IDD_EB4);
            udWnd = CreateUpDownControl(WS_CHILD | WS_BORDER | WS_VISIBLE |
                                        UDS_SETBUDDYINT | UDS_ALIGNRIGHT,
                                        20, 42, 50, 50,
                                        hdwnd,
                                        IDD_UPDOWN3,
                                        hMainInstance,
                                        hEboxWnd,
                                        MAXSPEED, 1, textXSpeed);

            /* initialize edit box with current message */
            SetDlgItemText(hdwnd, IDD_EB2, str);

            return 1;

        case WM_COMMAND :
                switch ( LOWORD(wParam))
                {
                    case IDOK :
                        /* set delay value  */
                        delay = GetDlgItemInt(hdwnd, IDD_EB1, NULL, 1);

                        /* get speed value */
                        textXSpeed = GetDlgItemInt(hdwnd, IDD_EB3, NULL, 1);
                        textYSpeed = GetDlgItemInt(hdwnd, IDD_EB4, NULL, 1);

                        /* get message string */
                        GetDlgItemText(hdwnd, IDD_EB2, str, MSGSIZE);

                        /* update regestry */
                        RegSetValueEx(hRegKey, "delay", 0,
                                    REG_DWORD, (LPBYTE) &delay, sizeof(DWORD));
                        RegSetValueEx(hRegKey, "message", 0,
                                    REG_SZ, (LPBYTE) str, sizeof(str)+1);
                        RegSetValueEx(hRegKey, "textXSpeed", 0,
                                    REG_DWORD, (LPBYTE) &textXSpeed, sizeof(DWORD));
                        RegSetValueEx(hRegKey, "textYSpeed", 0,
                                    REG_DWORD, (LPBYTE) &textYSpeed, sizeof(DWORD));

                        /* fall through to next case ... */
                    case IDCANCEL :
                        RegCloseKey(hRegKey);
                        EndDialog(hdwnd, 0);
                        return 1;
                }
        break;
    }
	return 0;
}

/* No classes to register. */
BOOL WINAPI RegisterDialogClasses(HINSTANCE hInst)
{
	return 1;
}




